{
  "description": "An EphemeralContainer is a temporary container that you may add to an existing Pod for user-initiated activities such as debugging. Ephemeral containers have no resource or scheduling guarantees, and they will not be restarted when they exit or when a Pod is removed or restarted. The kubelet may evict a Pod if an ephemeral container causes the Pod to exceed its resource allocation.\n\nTo add an ephemeral container, use the ephemeralcontainers subresource of an existing Pod. Ephemeral containers may not be removed or restarted.",
  "properties": {
    "args": {
      "description": "Arguments to the entrypoint. The image's CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. \"$$(VAR_NAME)\" will produce the string literal \"$(VAR_NAME)\". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell",
      "items": {
        "type": [
          "string",
          "null"
        ]
      },
      "type": [
        "array",
        "null"
      ],
      "x-kubernetes-list-type": "atomic"
    },
    "command": {
      "description": "Entrypoint array. Not executed within a shell. The image's ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container's environment. If a variable cannot be resolved, the reference in the input string will be unchanged. Double $$ are reduced to a single $, which allows for escaping the $(VAR_NAME) syntax: i.e. \"$$(VAR_NAME)\" will produce the string literal \"$(VAR_NAME)\". Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: https://kubernetes.io/docs/tasks/inject-data-application/define-command-argument-container/#running-a-command-in-a-shell",
      "items": {
        "type": [
          "string",
          "null"
        ]
      },
      "type": [
        "array",
        "null"
      ],
      "x-kubernetes-list-type": "atomic"
    },
    "env": {
      "description": "List of environment variables to set in the container. Cannot be updated.",
      "items": {
        "$ref": "/api/_definitions.json#/$defs/io.k8s.api.core.v1.EnvVar"
      },
      "type": [
        "array",
        "null"
      ],
      "x-kubernetes-list-map-keys": [
        "name"
      ],
      "x-kubernetes-list-type": "map",
      "x-kubernetes-patch-merge-key": "name",
      "x-kubernetes-patch-strategy": "merge"
    },
    "envFrom": {
      "description": "List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. All invalid keys will be reported as an event when the container is starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated.",
      "items": {
        "$ref": "/api/_definitions.json#/$defs/io.k8s.api.core.v1.EnvFromSource"
      },
      "type": [
        "array",
        "null"
      ],
      "x-kubernetes-list-type": "atomic"
    },
    "image": {
      "description": "Container image name. More info: https://kubernetes.io/docs/concepts/containers/images",
      "type": [
        "string",
        "null"
      ]
    },
    "imagePullPolicy": {
      "description": "Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: https://kubernetes.io/docs/concepts/containers/images#updating-images",
      "type": [
        "string",
        "null"
      ]
    },
    "lifecycle": {
      "$ref": "/api/_definitions.json#/$defs/io.k8s.api.core.v1.Lifecycle",
      "description": "Lifecycle is not allowed for ephemeral containers."
    },
    "livenessProbe": {
      "$ref": "/api/_definitions.json#/$defs/io.k8s.api.core.v1.Probe",
      "description": "Probes are not allowed for ephemeral containers."
    },
    "name": {
      "description": "Name of the ephemeral container specified as a DNS_LABEL. This name must be unique among all containers, init containers and ephemeral containers.",
      "type": [
        "string",
        "null"
      ]
    },
    "ports": {
      "description": "Ports are not allowed for ephemeral containers.",
      "items": {
        "$ref": "/api/_definitions.json#/$defs/io.k8s.api.core.v1.ContainerPort"
      },
      "type": [
        "array",
        "null"
      ],
      "x-kubernetes-list-map-keys": [
        "containerPort",
        "protocol"
      ],
      "x-kubernetes-list-type": "map",
      "x-kubernetes-patch-merge-key": "containerPort",
      "x-kubernetes-patch-strategy": "merge"
    },
    "readinessProbe": {
      "$ref": "/api/_definitions.json#/$defs/io.k8s.api.core.v1.Probe",
      "description": "Probes are not allowed for ephemeral containers."
    },
    "resizePolicy": {
      "description": "Resources resize policy for the container.",
      "items": {
        "$ref": "/api/_definitions.json#/$defs/io.k8s.api.core.v1.ContainerResizePolicy"
      },
      "type": [
        "array",
        "null"
      ],
      "x-kubernetes-list-type": "atomic"
    },
    "resources": {
      "$ref": "/api/_definitions.json#/$defs/io.k8s.api.core.v1.ResourceRequirements",
      "description": "Resources are not allowed for ephemeral containers. Ephemeral containers use spare resources already allocated to the pod."
    },
    "restartPolicy": {
      "description": "Restart policy for the container to manage the restart behavior of each container within a pod. This may only be set for init containers. You cannot set this field on ephemeral containers.",
      "type": [
        "string",
        "null"
      ]
    },
    "securityContext": {
      "$ref": "/api/_definitions.json#/$defs/io.k8s.api.core.v1.SecurityContext",
      "description": "Optional: SecurityContext defines the security options the ephemeral container should be run with. If set, the fields of SecurityContext override the equivalent fields of PodSecurityContext."
    },
    "startupProbe": {
      "$ref": "/api/_definitions.json#/$defs/io.k8s.api.core.v1.Probe",
      "description": "Probes are not allowed for ephemeral containers."
    },
    "stdin": {
      "description": "Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false.",
      "type": [
        "boolean",
        "null"
      ]
    },
    "stdinOnce": {
      "description": "Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false",
      "type": [
        "boolean",
        "null"
      ]
    },
    "targetContainerName": {
      "description": "If set, the name of the container from PodSpec that this ephemeral container targets. The ephemeral container will be run in the namespaces (IPC, PID, etc) of this container. If not set then the ephemeral container uses the namespaces configured in the Pod spec.\n\nThe container runtime must implement support for this feature. If the runtime does not support namespace targeting then the result of setting this field is undefined.",
      "type": [
        "string",
        "null"
      ]
    },
    "terminationMessagePath": {
      "description": "Optional: Path at which the file to which the container's termination message will be written is mounted into the container's filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated.",
      "type": [
        "string",
        "null"
      ]
    },
    "terminationMessagePolicy": {
      "description": "Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated.",
      "type": [
        "string",
        "null"
      ]
    },
    "tty": {
      "description": "Whether this container should allocate a TTY for itself, also requires 'stdin' to be true. Default is false.",
      "type": [
        "boolean",
        "null"
      ]
    },
    "volumeDevices": {
      "description": "volumeDevices is the list of block devices to be used by the container.",
      "items": {
        "$ref": "/api/_definitions.json#/$defs/io.k8s.api.core.v1.VolumeDevice"
      },
      "type": [
        "array",
        "null"
      ],
      "x-kubernetes-list-map-keys": [
        "devicePath"
      ],
      "x-kubernetes-list-type": "map",
      "x-kubernetes-patch-merge-key": "devicePath",
      "x-kubernetes-patch-strategy": "merge"
    },
    "volumeMounts": {
      "description": "Pod volumes to mount into the container's filesystem. Subpath mounts are not allowed for ephemeral containers. Cannot be updated.",
      "items": {
        "$ref": "/api/_definitions.json#/$defs/io.k8s.api.core.v1.VolumeMount"
      },
      "type": [
        "array",
        "null"
      ],
      "x-kubernetes-list-map-keys": [
        "mountPath"
      ],
      "x-kubernetes-list-type": "map",
      "x-kubernetes-patch-merge-key": "mountPath",
      "x-kubernetes-patch-strategy": "merge"
    },
    "workingDir": {
      "description": "Container's working directory. If not specified, the container runtime's default will be used, which might be configured in the container image. Cannot be updated.",
      "type": [
        "string",
        "null"
      ]
    }
  },
  "required": [
    "name"
  ],
  "type": "object",
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "$id": "https://kubernetes.io/api/ephemeralcontainer/v1"
}